<?php declare(strict_types=1);

namespace Lubian\AttributeMagic;

use DI\ContainerBuilder;
use Lubian\AttributeMagic\Infrastructure\Event\Dispatcher;
use Lubian\AttributeMagic\Infrastructure\Event\DispatcherFactory;
use Lubian\AttributeMagic\Infrastructure\Finder;
use Lubian\AttributeMagic\Infrastructure\HttpKernel;
use Lubian\AttributeMagic\Infrastructure\WebApp\Route\HandlerResolver;
use Symfony\Component\HttpFoundation\Request;

use function assert;

require_once __DIR__ . '/../vendor/autoload.php';
$cached = false;
$container = (new ContainerBuilder())->addDefinitions(
    [
        Finder::class => static fn(): Finder => new Finder(__DIR__, [], $cached),
        Dispatcher::class => static fn(DispatcherFactory $f): Dispatcher
            => $f->getDispatcher($cached),
        HandlerResolver::class => static fn(Dispatcher $d): HandlerResolver
            => new HandlerResolver($d, $cached),
    ],
)->build();
$kernel = $container->get(HttpKernel::class);
assert($kernel instanceof HttpKernel);
$response = $kernel->handle(Request::createFromGlobals());
$response->send();
exit();
