<?php declare(strict_types=1);

namespace Lubian\AttributeMagic\Infrastructure;

use Exception;
use Lubian\AttributeMagic\Infrastructure\Event\Dispatcher;
use Lubian\AttributeMagic\Infrastructure\WebApp\Request\RequestEvent;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

class HttpKernel
{
    public function __construct(
        private readonly Dispatcher $dispatcher
    ) {}

    public function handle(Request $request): Response
    {
        $requestEvent = new RequestEvent($request);
        $this->dispatcher->dispatch($requestEvent);
        return $requestEvent->response ?? throw new Exception('errror');
    }
}
